/*
 * Copyright (c) 2012 poorcore
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditionsare met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holders nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
*/

/***********************************************************************/
/*                                                                     */
/*  FILE        :cm64dout.c                                            */
/*  DATE        :Mon, Aug 16, 2010                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :SH72620                                               */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.16).    */
/*                                                                     */
/***********************************************************************/
                  


//#include "typedefine.h"
#include "iodefine.h"
#include <math.h>
#include <machine.h>
#include "cm64dout.h"

#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

#pragma inline(cpg_init)
#pragma inline(bus_init)
#pragma inline(gpio_init)

#ifdef ENABLE_PCM
#pragma inline(ssif3_init)
#endif /* ENABLE_PCM */

#pragma inline(spdif_init)

#ifdef ENABLE_VOLUME
#pragma inline(adc_init)
#endif /* ENABLE_VOLUME */

#ifdef ENABLE_LA_VOLUME
#pragma inline(mtu2_init)
#endif /* ENABLE_LA_VOLUME */

#pragma inline(cm64_init)

#ifdef ENABLE_MINUS_ONE_CLEAR
#pragma inline(clear_minus_one_noise)
#endif /* ENABLE_MINUS_ONE_CLEAR */

#ifdef OUTPUT_DATA_24BIT
#pragma inline(clip_int24)
#else /* OUTPUT_DATA_24BIT */
#pragma inline(clip_int16)
#endif /* OUTPUT_DATA_24BIT */

#ifdef ENABLE_VOLUME
#pragma inline(get_volume)
#endif /* ENABLE_VOLUME */

#pragma inline(mix_data)
#pragma inline(out_data)
#pragma inline(la_rsyn1_state)
#pragma inline(la_rsyn2_state)
#pragma inline(la_lsyn1_state)
#pragma inline(la_lsyn2_state)
#pragma inline(la_rrev_state)
#pragma inline(la_lrev_state)
#pragma inline(la_data)

#ifdef ENABLE_VOLUME
#pragma inline(get_adc_data)
#endif /* ENABLE_VOLUME */


#ifdef ENABLE_LA_VOLUME
#pragma inline(get_la_volume)
#endif /* ENABLE_LA_VOLUME */

/* prototype */
static void cpg_init(void);
static void bus_init(void);
static void gpio_init(void);

#ifdef ENABLE_PCM
static void ssif3_init(void);
#endif /* ENABLE_PCM */

static void spdif_init(void);

#ifdef ENABLE_VOLUME
static void adc_init(void);
#endif /* ENABLE_VOLUME */

#ifdef ENABLE_LA_VOLUME
static void mtu2_init(void);
#endif /* ENABLE_LA_VOLUME */

static void cm64_init(void);

#ifdef ENABLE_MINUS_ONE_CLEAR
static int16 clear_minus_one_noise(int state, int16 data);
#endif /* ENABLE_MINUS_ONE_CLEAR */

#ifdef OUTPUT_DATA_24BIT
static int32 clip_int24(int32 data);
#else /* OUTPUT_DATA_24BIT */
static int32 clip_int16(int32 data);
#endif /* OUTPUT_DATA_24BIT */

#ifdef ENABLE_VOLUME
static double get_volume(void);
#endif /* ENABLE_VOLUME */

#ifdef ENABLE_LA_VOLUME
static void get_la_volume(void);
#endif /* ENABLE_LA_VOLUME */

static void mix_data(void);
static void out_data(void);
static void la_rsyn1_state(void);
static void la_rsyn2_state(void);
static void la_lsyn1_state(void);
static void la_lsyn2_state(void);
static void la_rrev_state(void);
static void la_lrev_state(void);
static void la_data(void);

#ifdef ENABLE_VOLUME
static void get_adc_data(void);
#endif /* ENABLE_VOLUME */

/* global */
#ifdef ENABLE_VOLUME
T_VOLUME volume_t;
#endif /* ENABLE_VOLUME */

#ifdef ENABLE_LA_VOLUME
T_LA_VOLUME la_volume_t;
#endif /* ENABLE_LA_VOLUME */

T_LA 	la_t;

#ifdef ENABLE_PCM
T_PCM	pcm_t;
#endif /* ENABLE_PCM */

T_CM64	cm64_t;

#define INDEX16(i)	((i + 16) & 15)
#define INDEX1024(i)	((i + 1024) & 1023)
#define RINT32(data)	((int32)((data < 0.0)? ceil(data - 0.5) : floor(data + 0.5)))
#define INT32_TO_24BIT(data) ((uint32)(data & 0x00FFFFFF))
#define INT32_TO_16BIT(data) ((uint32)(data & 0x0000FFFF))
#define	GET_LA_AUDIO_DATA(data)	\
			data = LA_AUDIO_DATA;		\
			data = (data & 0x8000) | ((~data) & 0x7FFF);

static void cpg_init(void)
{
	CPG.FRQCR.WORD = 0x0104;
}

static void bus_init(void)
{
	PORT.PFCR1.BIT.PF5MD = 1;		/* nCS5 */
	PORT.PCCR0.BIT.PC1MD = 1;		/* nRD */
	
	PORT.PDCR3.WORD = 0x1111;		/* PD[15..12] D15..12 */
	PORT.PDCR2.WORD	= 0x1111;		/* PD[11.. 8] D11..8  */
	PORT.PDCR1.WORD = 0x1111;		/* PD[ 7.. 4] D7..4   */
	PORT.PDCR0.WORD = 0x1111;		/* PD[ 3.. 0] D3..0   */
	
	BSC.CS5BCR.BIT.IWW = 0;				/* 0 cycle */
	BSC.CS5BCR.BIT.IWRWD = 0;			/* 0 cycle */
	BSC.CS5BCR.BIT.IWRWS = 0;			/* 0 cycle */
	BSC.CS5BCR.BIT.IWRRD = 0;			/* 0 cycle */
	BSC.CS5BCR.BIT.IWRRS = 0;			/* 0 cycle */
	BSC.CS5BCR.BIT.TYPE = 0;			/* Normal Area */
	BSC.CS5BCR.BIT.ENDIAN = 0;			/* Big Endian */
	BSC.CS5BCR.BIT.BSZ = 2;				/* 16bit */
	BSC.CS5WCR.NORMAL.BIT.WW = 0;		/* same WR */
	BSC.CS5WCR.NORMAL.BIT.SW = 0;		/* 0.5 cycle */
	BSC.CS5WCR.NORMAL.BIT.WR = 0;		/* 0 cycle */
	BSC.CS5WCR.NORMAL.BIT.WM = 1;		/* disable outside wait */
	BSC.CS5WCR.NORMAL.BIT.HW = 0;		/* 0.5 cycle */
}

static void gpio_init(void)
{
	PORT.PCDR0.BIT.PC2DR = 0;		/* Enable */
	PORT.PCIOR0.BIT.PC2IOR = 1;		/* PC2 Output */
	PORT.PCCR0.BIT.PC2MD = 0;		/* PC2 GPIO */
	
	PORT.PCDR0.BIT.PC8DR = 1;		/* LED off */
	PORT.PCIOR0.BIT.PC8IOR = 1;		/* PC8 output */
	PORT.PCCR2.BIT.PC8MD = 0;		/* PC8 GPIO */
	
	PORT.PECR0.BIT.PE0MD = 2;		/* AUDIO_CLK */
	
	PORT.PBIOR1.WORD &= 0xFFF0;		/* PB[19..16] input */
	PORT.PBCR4.WORD = 0x0000;		/* PB[19..16] GPIO */
	
	PORT.PGIOR0.WORD &= 0xFFFC;		/* PG[1..0] input */
	PORT.PGCR7.BIT.PG0MD = 0;		/* PG0 GPIO */
	PORT.PGCR0.BIT.PG1MD = 0;		/* PG1 GPIO */
}

#ifdef ENABLE_PCM
static void ssif3_init(void)
{
	CPG.STBCR6.BIT.MSTP64 = 0;			/* SSIF3 enable */	
	PORT.PFCR2.BIT.PF8MD = 2;			/* select SSIDATA3 */
	PORT.PFCR1.BIT.PF7MD = 2;			/* select SSIWS3 */
	PORT.PFCR1.BIT.PF6MD = 2;			/* select SSISCK3 */
	
	SSIF3.SSICR.LONG = 0;				/* Clear Control Register */
	SSIF3.SSICR.BIT.CKS = 1;			/* AUDIO_CLK */
	SSIF3.SSICR.BIT.CHNL = 0;			/* One channel per system word */
	SSIF3.SSICR.BIT.DWL = 2;			/* 18 bit data word */
	SSIF3.SSICR.BIT.SWL = 3;			/* 32 bit system word */
	SSIF3.SSICR.BIT.SCKD = 0;			/* Slave mode, serial clock in */
	SSIF3.SSICR.BIT.SWSD = 0;			/* Slave mode, serial clock in */
	SSIF3.SSICR.BIT.SCKP = 0;			/* Sampling timing: rising edge */
	SSIF3.SSICR.BIT.SWSP = 0;			/* Low High */
	SSIF3.SSICR.BIT.SPDP = 0;			/* Low Padding */
	SSIF3.SSICR.BIT.SDTA = 1;			/* Padding bit, serial data */
	SSIF3.SSICR.BIT.PDTA = 1;			/* MSB first */
	SSIF3.SSICR.BIT.DEL = 1;			/* No serial data delay */
//	SSIF3.SSICR.BIT.CKDV = 2; 			/* 1/4 clock */
	SSIF3.SSICR.BIT.MUEN = 0;			/* Mute off */
	
	SSIF3.SSICR.BIT.REN = 1;			/* Rx enable */

	SSIF3.SSIFCR.BIT.RTRG = 0;			/* Rx Trigger 1 data */	
	SSIF3.SSIFCR.BIT.RIE = 1;			/* Rx interrupt enable */
	INTC.IPR15.BIT._SSI3 = 1;
}
#endif /* ENABLE_PCM */

static void spdif_init(void)
{
	INTC.IPR16.BIT._SPDIF  = 0;
	CPG.STBCR7.BIT.MSTP76 = 0;			/* SPDIF enable */
	SPDIF.CTRL.BIT.TME = 0;				/* SPDIF Tx disable */
	
	/* CTRL */
	SPDIF.CTRL.BIT.CKS = 1;				/* AUDIO_CLK */
#ifdef OUTPUT_DATA_24BIT
	SPDIF.CTRL.BIT.TASS = 2;			/* 24bits */
#else
	SPDIF.CTRL.BIT.TASS = 0;			/* 16bits */
#endif

//	SPDIF.CTRL.BIT.NCSI = 1;			/* New Channel Status */
	SPDIF.CTRL.BIT.AOS = 1;				/* Audio only sample */
	
	/* Lch status */
	SPDIF.TLCS.BIT.CLAC = 0;			/* Clock level 2 */
	SPDIF.TLCS.BIT.FS = 3;				/* 32kHz */
	SPDIF.TLCS.BIT.CHNO = 1;			/* Lch */
	SPDIF.TLCS.BIT.CTL = 2;				/* Copy Enable */
	/* Rch status */
	SPDIF.TRCS.BIT.CLAC = 0;			/* Clock level 2 */
	SPDIF.TRCS.BIT.FS = 3;				/* 32kHz */
	SPDIF.TRCS.BIT.CHNO = 2;			/* Rch */
	SPDIF.TRCS.BIT.CTL = 2;				/* Copy Enable */
	
	SPDIF.CTRL.BIT.TME = 1;				/* Tx enable */
	
	PORT.PFCR3.BIT.PF12MD = 5;			/* select SPDIF_OUT */

	SPDIF.TUI = 0x00000000;				/* U bit All 0b */
	SPDIF.TLCA = 0;						/* L Channel Data */
	SPDIF.TRCA = 0;						/* R Channel Data */
}

#ifdef ENABLE_VOLUME
static void adc_init(void)
{
	CPG.STBCR3.BIT.MSTP32 = 0;			/* ADC enable */
	PORT.PHCR0.BIT.PH0MD = 1;			/* select AN0 */
	ADC.ADCSR.BIT.TRGS = 0;				/* disable external trigger */
//	ADC.ADCSR.BIT.CKS = 5;				/* Convert Time = 548 tcyc(max) */
	ADC.ADCSR.BIT.CKS = 0;				/* Convert Time */
	ADC.ADCSR.BIT.MDS = 0;				/* single mode */
	ADC.ADCSR.BIT.CH = 0;				/* AN0 only */
	ADC.ADCSR.BIT.ADST = 1;				/* AD convert start */
}
#endif /* ENABLE_VOLUME */

#ifdef ENABLE_LA_VOLUME
static void mtu2_init(void)
{
	CPG.STBCR3.BIT.MSTP35 = 0; 			/* enable MTU2 clock */
	MTU2.TCR_4.BIT.TPSC = 0;			/* inline clock, P_phi / 1 */
	MTU2.TCR_4.BIT.CKEG = 0;			/* count on rising edge */
	MTU2.TCR_4.BIT.CCLR = 2;			/* counter clear on TGRB input capture */
	MTU2.TMDR_4.BIT.MD = 0;				/* normal mode */
	MTU2.TMDR_4.BIT.BFA = 0;			/* disable buffer */
	MTU2.TMDR_4.BIT.BFB = 0;			/* disable buffer */
	MTU2.TIORH_4.BIT.IOB = 9;			/* input capture on folling edge */
	MTU2.TIORH_4.BIT.IOA = 8;			/* input capture on rising edge */
	
	PORT.PCCR1.BIT.PC6MD = 2;			/* select TIOC4B */
	PORT.PCCR1.BIT.PC5MD = 2;			/* select TIOC4A */
	
	MTU2.TSTR.BIT.CST4 = 1;				/* TCNT_4 count start */
}
#endif /* ENABLE_LA_VOLUME */

static void cm64_init(void)
{
	cpg_init();
	bus_init();
	gpio_init();
	
	memset(&la_t, 0, sizeof(T_LA));
	
#ifdef ENABLE_PCM
	memset(&pcm_t, 0, sizeof(T_PCM));
#endif /* ENABLE_PCM */
	
	memset(&cm64_t, 0, sizeof(T_CM64));
	
#ifdef ENABLE_VOLUME
	memset(&volume_t, 0, sizeof(T_VOLUME));
#endif /* ENABLE_VOLUME */

#ifdef ENABLE_LA_VOLUME
	memset(&la_volume_t, 0, sizeof(T_LA_VOLUME));
#endif /* ENABLE_LA_VOLUME */
	
	la_t.PrevSelect = LA_SELECT_INVALID;
	
#ifdef ENABLE_VOLUME
	adc_init();
#endif /* ENABLE_VOLUME */

#ifdef ENABLE_LA_VOLUME
	mtu2_init();
#endif /* ENABLE_LA_VOLUME */
	
#ifdef ENABLE_PCM
	ssif3_init();
#endif /* ENABLE_PCM */

	set_imask(0);

	spdif_init();
}

#ifdef ENABLE_MINUS_ONE_CLEAR
static int16 clear_minus_one_noise(int state, int16 data)
{
	uint16 count;
	int16 ret;
	
	count = la_t.M1Count[state];
	
	if(data == -1){
		count++;
		if(count >= 10){
			ret = 0;
			count = 9;
		} else {
			ret = data;
		}
	} else {
		ret = data;
		count = 0;
	}
	
	la_t.M1Count[state] = count;
	
	return(ret);
}
#endif /* ENABLE_MINUS_ONE_CLEAR */

#ifdef OUTPUT_DATA_24BIT
static int32 clip_int24(int32 data)
{
	int32 ret;
	
	if(data > MAX_INT24){
		ret = MAX_INT24;
	} else if(data < MIN_INT24){
		ret = MIN_INT24;
	} else {
		ret = data;
	}
	
	return(ret);
}
#else /* OUTPUT_DATA_24BIT */
static int32 clip_int16(int32 data)
{
	int32 ret;
	
	if(data > MAX_INT16){
		ret = MAX_INT16;
	} else if(data < MIN_INT16){
		ret = MIN_INT16;
	} else {
		ret = data;
	}
	
	return(ret);
}
#endif /* OUTPUT_DATA_24BIT */

#ifdef ENABLE_VOLUME
static double get_volume(void)
{
	uint16 current;
	double volume;
	double ratio;
	
	current = volume_t.Current;
	volume = ((double)current) * 0.0039215686274509804;	/* 0.0 < volume < 1.0 */
#ifdef VOLUME_CURVE_B_TO_A
	ratio = (pow(10.0, volume) - 1.0) * 0.11111111111111111;
#else /* VOLUME_CURVE_B_TO_A */
	ratio = volume;
#endif /* VOLUME_CURVE_B_TO_A */
	ratio = ratio * 2.0;
		
	return(ratio);
}
#endif /* ENABLE_VOLUME */

static void mix_data(void)
{
	double leftorg;
	double rightorg;
	int32 left;
	int32 right;
	uint16 current;
	uint16 leftzerocount;
	uint16 rightzerocount;
	
#ifdef ENABLE_VOLUME
	double volume;
#endif /* ENABLE_VOLUME */

#ifdef ENABLE_LA_VOLUME
	double la_volume;
#endif /* ENABLE_LA_VOLUME */
	
	current = cm64_t.Current;
	
#ifdef ENABLE_PCM
	leftorg =  (la_t.LeftBuf[current] * 0.64279411764705882)  + (double)pcm_t.LeftBuf[current];
	rightorg = (la_t.RightBuf[current] * 0.64279411764705882) + (double)pcm_t.RightBuf[current];
#else /* ENABLE_PCM */
	/* LÂ݂̏ꍇ */
	leftorg =  (la_t.LeftBuf[current] * 0.64279411764705882);
	rightorg = (la_t.RightBuf[current] * 0.64279411764705882);
#endif /* ENABLE_PCM */

	la_t.DataIn--;
	
#ifdef ENABLE_PCM 
	pcm_t.DataIn--;
#endif /* ENABLE_PCM */
	
	la_t.LeftBuf[current] = 0.0;
	la_t.RightBuf[current] = 0.0;
	
#ifdef ENABLE_PCM
	pcm_t.LeftBuf[current] = 0;
	pcm_t.RightBuf[current] = 0;
#endif /* ENABLE_PCM */

	/* o덷NA */
	leftzerocount = cm64_t.LeftZeroCount;
	rightzerocount = cm64_t.RightZeroCount;
	
	if(leftorg == 0.0){
		leftzerocount++;
		if(leftzerocount >= 10){
			cm64_t.LeftError = 0.0;
			leftzerocount = 9;
		}
	} else {
		leftzerocount = 0;
	}
	
	if(rightorg == 0.0){
		rightzerocount++;
		if(rightzerocount >= 10){
			cm64_t.RightError = 0.0;
			rightzerocount = 9;
		}
	} else {
		rightzerocount = 0;
	}
	
	cm64_t.LeftZeroCount = leftzerocount;
	cm64_t.RightZeroCount = rightzerocount;	

#ifdef ENABLE_LA_VOLUME
	la_volume = ((double)la_volume_t.Volume) * 0.00390625;
	leftorg = leftorg * la_volume;
	rightorg = rightorg * la_volume;
#endif /* ENABLE_LA_VOLUME */

#ifdef ENABLE_VOLUME	
	/* Volume */
	volume = get_volume();
	leftorg = leftorg * volume;
	rightorg = rightorg * volume;
#endif /* ENABLE_VOLUME */
	
#ifdef OUTPUT_DATA_24BIT
	leftorg = leftorg * 256.0;
	rightorg = rightorg * 256.0;
#endif
	
	leftorg += cm64_t.LeftError;
	rightorg += cm64_t.RightError;
	left = RINT32(leftorg);
	right = RINT32(rightorg);

	/* 덷L */	
	cm64_t.LeftError = leftorg - (double)left;
	cm64_t.RightError = rightorg - (double)right;
	
#ifdef OUTPUT_DATA_24BIT
	/* 24bit output */
	left = clip_int24(left);
	right = clip_int24(right);
	cm64_t.LeftBuf[current] = INT32_TO_24BIT(left);
	cm64_t.RightBuf[current] = INT32_TO_24BIT(right);
#else	/* OUTPUT_DATA_24BIT */
	/* 16bit output */
	left = clip_int16(left);
	right = clip_int16(right);
	cm64_t.LeftBuf[current] = INT32_TO_16BIT(left);
	cm64_t.RightBuf[current] = INT32_TO_16BIT(right);
#endif	/* OUTPUT_DATA_24BIT */
	
	cm64_t.DataIn++;
}

static void out_data(void)
{
	uint16 current;
	
	if(SPDIF.STAT.BIT.CBTX == 1){
		current = cm64_t.Current;
		
		SPDIF.TLCA = cm64_t.LeftBuf[current];
		SPDIF.TRCA = cm64_t.RightBuf[current];
		
		cm64_t.LeftBuf[current] = 0;
		cm64_t.RightBuf[current] = 0;
		
		cm64_t.Current = INDEX16(current + 1);
		cm64_t.DataIn--;
	}
}

static void la_rsyn1_state(void)
{
	int16 indata;
	uint16 current;
	double work;
	
	GET_LA_AUDIO_DATA(indata);
	
#ifdef ENABLE_MINUS_ONE_CLEAR
	indata = clear_minus_one_noise(LA_STATE_RSYN1, indata);
#endif /* ENABLE_MINUS_ONE_CLEAR */
	
	current = la_t.Current;
	work = (double)indata;

	la_t.RightBuf[current] = work;
	
#ifdef ENABLE_LA_VOLUME
	/* LÃ{[擾 */
	get_la_volume();
#endif /* ENABLE_LA_VOLUME */
}

static void la_rsyn2_state()
{
	int16 indata;
	uint16 current;
	double work;
	
	GET_LA_AUDIO_DATA(indata);
	
#ifdef ENABLE_MINUS_ONE_CLEAR
	indata = clear_minus_one_noise(LA_STATE_RSYN2, indata);
#endif /* ENABLE_MINUS_ONE_CLEAR */
	
	current = la_t.Current;
	work = (double)indata;
	
	la_t.RightBuf[current] += work;
	
	/*  */
#ifdef ENABLE_PCM
	if((la_t.DataIn > 0) && (pcm_t.DataIn > 0)){
#else /* ENABLE_PCM */
	if(la_t.DataIn > 0){
#endif /* ENABLE_PCM */
		mix_data();
	}		
}

static void la_lsyn1_state()
{
	int16 indata;
	uint16 current;
	double work;
	
	GET_LA_AUDIO_DATA(indata);

#ifdef ENABLE_MINUS_ONE_CLEAR
	indata = clear_minus_one_noise(LA_STATE_LSYN1, indata);
#endif /* ENABLE_MINUS_ONE_CLEAR */

	current = la_t.Current;
	work = (double)indata;
	
	la_t.LeftBuf[current] = work;
	
	/* S/PDIFo */
	if(cm64_t.DataIn > 0){
		out_data();
	}	
}

static void la_lsyn2_state()
{
	int16 indata;
	uint16 current;
	double work;
	
	GET_LA_AUDIO_DATA(indata);
	
#ifdef ENABLE_MINUS_ONE_CLEAR
	indata = clear_minus_one_noise(LA_STATE_LSYN2, indata);
#endif /* ENABLE_MINUS_ONE_CLEAR */

	current = la_t.Current;
	work = (double)indata;
	
	la_t.LeftBuf[current] += work;
	
#ifdef ENABLE_VOLUME
	get_adc_data();
#endif /* ENABLE_VOLUME */

}

static void la_rrev_state(void)
{
	int16 indata;
	uint16 current;
	double work;
	
	GET_LA_AUDIO_DATA(indata);

#ifdef ENABLE_MINUS_ONE_CLEAR
	indata = clear_minus_one_noise(LA_STATE_RREV, indata);
#endif /* ENABLE_MINUS_ONE_CLEAR */

	current = la_t.Current;
	work = ((double)indata) * 0.68;
	
	la_t.RightBuf[current] += work;
}

static void la_lrev_state()
{
	int16 indata;
	uint16 current;
	double work;
	
	GET_LA_AUDIO_DATA(indata);
	
#ifdef ENABLE_MINUS_ONE_CLEAR
	indata = clear_minus_one_noise(LA_STATE_LREV, indata);
#endif /* ENABLE_MINUS_ONE_CLEAR */

	current = la_t.Current;
	work = ((double)indata) * 0.68;
	
	la_t.LeftBuf[current] += work;
	
	if(la_t.DataIn < 2){
		la_t.Current = INDEX16(current + 1);
		la_t.DataIn++;
	}
}

static void la_data(void)
{
	uint16 prev;
	uint16 current;
	
	current = PORT.PBDR1.WORD;
	current &= LA_SELECT_MASK;
	prev = la_t.PrevSelect;
	
	if(prev != current){
		switch(current){
			case LA_SELECT_RSYN1:
				if((prev == LA_SELECT_LREV) || (prev == LA_SELECT_INVALID)){
					la_rsyn1_state();
					prev = LA_SELECT_RSYN1;
				}
				break;
			case LA_SELECT_RSYN2:
				if((prev == LA_SELECT_RSYN1) || (prev == LA_SELECT_INVALID)){
					la_rsyn2_state();
					prev = LA_SELECT_RSYN2;
				}
				break;
			case LA_SELECT_LSYN1:
				if((prev == LA_SELECT_RSYN2) || (prev == LA_SELECT_INVALID)){
					la_lsyn1_state();
					prev = LA_SELECT_LSYN1;
				}
				break;
			case LA_SELECT_LSYN2:
				if((prev == LA_SELECT_LSYN1) || (prev == LA_SELECT_INVALID)){
					la_lsyn2_state();
					prev = LA_SELECT_LSYN2;
				}
				break;
			case LA_SELECT_RREV:
				if((prev == LA_SELECT_LSYN2) || (prev == LA_SELECT_INVALID)){
					la_rrev_state();
					prev = LA_SELECT_RREV;
				}	
				break;
			case LA_SELECT_LREV:
				if((prev == LA_SELECT_RREV) || (prev == LA_SELECT_INVALID)){
					la_lrev_state();
					prev = LA_SELECT_LREV;
				}
				break;
			default:
				break;
		}
		
		la_t.PrevSelect = prev;
	}
}

#ifdef ENABLE_VOLUME
static void get_adc_data(void)
{
	uint16 adcdata;
	uint16 volume;
	int32 sub;
	
	if(ADC.ADCSR.BIT.ADF == 1){
		ADC.ADCSR.BIT.ADF = 0;
		adcdata = ADC.ADDRA.WORD >> 8; 		/* 256 step */
		ADC.ADCSR.BIT.ADST = 1;
		
		volume_t.Sum += adcdata;
		volume_t.Count++;
		if(volume_t.Count >= MAX_VOLUME_COUNT){
			volume = volume_t.Sum / MAX_VOLUME_COUNT;
			sub = (int32)volume - (int32)volume_t.Current;
			if((sub >= 2) || (sub <= -2)){
				volume_t.Current = volume;
			}
			volume_t.Sum = 0;
			volume_t.Count = 0;
		}	
	}
}
#endif /* ENABLE_VOLUME */

#ifdef ENABLE_LA_VOLUME
static void get_la_volume(void)
{
	uint16 tcnt;
	uint16 volume;
	uint16 prev;
	uint32 tmp;
	uint16 count;
	uint16 prevtcnt;
	uint16 current;
	uint32 sum;
	uint16 sample;
	uint8  tcfv;
	
	current = la_volume_t.Current;
	prev = la_volume_t.Volume;
	prevtcnt = la_volume_t.Tcnt;
	sum = la_volume_t.Sum;
	
	if(MTU2.TSR_4.BIT.TGFA == 1){
		tcnt = MTU2.TGRA_4.WORD;
		MTU2.TSR_4.BIT.TGFA = 0;	/* clear */
		
		if(tcnt <= LA_VOLUME_PWM_CYCLE){
			tmp = (((uint32)(LA_VOLUME_PWM_CYCLE - tcnt)) << 8 << 8) / ((uint32)LA_VOLUME_PWM_CYCLE);
			sample = (uint16)(tmp >> 8);
			if(sample < 256){
				if((tmp & 0x000000FF) >= 128){
					sample++;
				}
			} else {
				sample = 256;
			}
		} else {
			sample = la_volume_t.Sample[INDEX1024(current - 1)];
		}
		
		sum += (uint32)sample;
		sum -= (uint32)la_volume_t.Sample[INDEX1024(current + 1)];
		
		tmp = (((uint32)sum) << 8) >> 10;
		volume = (uint16)(sum >> 10);
		if((tmp & 0x000000FF) >= 128){
			if(volume != prev){
				volume++;
			}
		} else {
			if((volume + 1) == prev){
				volume++;
			}
		}
		la_volume_t.Volume = volume;
		la_volume_t.Sample[current] = sample;
		la_volume_t.Sum = sum;
		la_volume_t.Tcnt = tcnt;
		la_volume_t.Current = INDEX1024(current + 1);
	} else {
		tcnt = MTU2.TCNT_4.WORD;
		tcfv = MTU2.TSR_4.BIT.TCFV;
		if((tcfv != 0) || (tcnt >= LA_VOLUME_PWM_CYCLE)){
			if(tcfv != 0){
				MTU2.TSR_4.BIT.TCFV = 0;
			}
			
			if(tcnt < prevtcnt){
				tmp = TIMER_CNT_MAX - prevtcnt + 1 + tcnt;
			} else {
				tmp = tcnt - prevtcnt;
			}
		
			if(tmp >= LA_VOLUME_PWM_CYCLE){
				sample = 256;
			
				if(prevtcnt <= (TIMER_CNT_MAX - LA_VOLUME_PWM_CYCLE)){
					tmp = prevtcnt + LA_VOLUME_PWM_CYCLE;
				} else {
					tmp = LA_VOLUME_PWM_CYCLE - (TIMER_CNT_MAX - prevtcnt + 1);
				}
				tcnt = tmp;
			
				sum += (uint32)sample;
				sum -= (uint32)la_volume_t.Sample[INDEX1024(current + 1)];
			
				tmp = (((uint32)sum) << 8) >> 10;
				volume = (uint16)(sum >> 10);
				if((tmp & 0x000000FF) >= 128){
					if(volume != prev){
						volume++;
					}
				} else {
					if((volume + 1) == prev){
						volume++;
					}
				}
				la_volume_t.Volume = volume;
				la_volume_t.Sample[current] = sample;
				la_volume_t.Sum = sum;
				la_volume_t.Tcnt = tcnt;
				la_volume_t.Current = INDEX1024(current + 1);
			}
		}
	}
}
#endif /* ENABLE_LA_VOLUME */

void int_ssif3(void)
{
#ifdef ENABLE_PCM
	uint16 current;
	uint16 select;
	uint32 indata;
	
	select = PORT.PGDR0.WORD & PCM_SELECT_MASK;
	indata = SSIF3.SSIFRDR & 0x0000FFFF;
	SSIF3.SSIFSR.BIT.RDF = 0;

	if(select == PCM_SELECT_2){
		current = pcm_t.Current;
		if(indata <= MAX_INT16){
			pcm_t.RightBuf[current] = (int16)indata;
		} else {
			pcm_t.RightBuf[current] = (int16)(indata - MAX_UINT16 - 1);
		}	
	} else if(select == PCM_SELECT_1){
		current = pcm_t.Current;
		if(indata <= MAX_INT16){
			pcm_t.LeftBuf[current] = (int16)indata;
		} else {
			pcm_t.LeftBuf[current] = (int16)(indata - MAX_UINT16 - 1);
		}

		if(pcm_t.DataIn < 2){
			pcm_t.Current = INDEX16(current + 1);
			pcm_t.DataIn++;
		}
	}
#endif /* ENABLE_PCM */
}

void main(void)
{
	cm64_init();	/* Initialize */
	
	while(1){
		la_data();
	}	
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
