/*
 * Copyright (c) 2012 poorcore
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditionsare met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holders nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef _CM64DOUT_H_
#define _CM64DOUT_H_

/* CONFIG */
#define ENABLE_PCM					/* CM32P enable */
/* o̓f[^̃rbg̑I 16bit or 24bit */
// #define OUTPUT_DATA_16BIT			/* 16bit default */
#define OUTPUT_DATA_24BIT			/* 24bit */

#define ENABLE_VOLUME				/* Volume enable */
//#define VOLUME_CURVE_B_TO_A			/* BJ[u{[AJ[u{[ƂĎgp */

#define ENABLE_MINUS_ONE_CLEAR		/* LA-1o͂Ă̂0NA@\̗L */

#define ENABLE_LA_VOLUME			/* LÃ{[PWMǂݎ */

typedef signed char int8;
typedef unsigned char uint8;
typedef signed short int16;
typedef unsigned short uint16;
typedef signed long int32;
typedef unsigned long uint32;
typedef signed long long int64;
typedef unsigned long long uint64;

#define MAX_INT24	(8388607)
#define MIN_INT24	(-8388608)
#define MAX_INT16	(32767)
#define MIN_INT16	(-32768)
#define MAX_UINT16	(65535)

#define LA_AUDIO_DATA		(*(volatile int16 *)0x34000000)

#define LA_SELECT_RSYN1	(0x0008)
#define LA_SELECT_RSYN2	(0x0009)
#define LA_SELECT_LSYN1	(0x000C)
#define LA_SELECT_LSYN2	(0x000D)
#define LA_SELECT_RREV		(0x000E)
#define LA_SELECT_LREV		(0x000F)
#define LA_SELECT_MASK		(0x000F)
#define LA_SELECT_INVALID	(0xFFFF)

#define		PCM_SELECT_MASK		(0x0003)
#define		PCM_SELECT_0		(0x0000)
#define		PCM_SELECT_1		(0x0001)
#define		PCM_SELECT_2		(0x0002)
#define		PCM_SELECT_3		(0x0003)

#define MAX_VOLUME_COUNT	(3200)

#define TIMER_CNT_MAX (65535)
#define LA_VOLUME_CHECK_CNT_MAX	(5)		/* {[őƂȂĂ邱Ƃ𔻒肷܂ł̃Tv */
#define LA_VOLUME_PWM_CYCLE (1536)		/* ǂݎPWM 1TCN 4MHz 256 stateNbN24MHzœǂݎ */

enum la_state {
	LA_STATE_RSYN1 = 0,
	LA_STATE_RSYN2,
	LA_STATE_LSYN1,
	LA_STATE_LSYN2,
	LA_STATE_RREV,
	LA_STATE_LREV,
	NUM_LA_STATE
};

#ifdef ENABLE_VOLUME
typedef struct {
	uint16 Count;
	uint16 Current;
	uint32 Sum;
} T_VOLUME;
#endif /* ENABLE_VOLUME */

#ifdef ENABLE_LA_VOLUME
typedef struct {
	uint16 Volume;
	uint16 Tcnt;
	uint16 Current;
	uint16 Reseved;
	uint32 Sum;
	uint16 Sample[1024];
} T_LA_VOLUME;
#endif /* ENABLE_LA_VOLUME */

typedef struct {
	uint16 Current;
	uint16 DataIn;
	double LeftBuf[16];
	double RightBuf[16];
	uint16 PrevSelect;
#ifdef ENABLE_MINUS_ONE_CLEAR
	uint16 M1Count[NUM_LA_STATE];
#endif /* ENABLE_MINUS_ONE_CLEAR */
} T_LA;

#ifdef ENABLE_PCM
typedef struct {
	uint16 Current;
	uint16 DataIn;
	int16 LeftBuf[16];
	int16 RightBuf[16];
} T_PCM;
#endif /* ENABLE_PCM */

typedef struct {
	uint16 Current;
	uint16 DataIn;
	uint32 LeftBuf[16];
	uint32 RightBuf[16];
	double LeftError;
	double RightError;
	uint16 LeftZeroCount;
	uint16 RightZeroCount;
} T_CM64;

#endif